SET @configuration_group_id=0;
SELECT (@configuration_group_id:=configuration_group_id) 
FROM configuration_group 
WHERE configuration_group_title = 'Simple SEO URLs' 
LIMIT 1;
DELETE FROM configuration WHERE configuration_group_id = @configuration_group_id AND @configuration_group_id != 0;
DELETE FROM configuration_group WHERE configuration_group_id = @configuration_group_id AND @configuration_group_id != 0;

INSERT INTO configuration_group (configuration_group_id, configuration_group_title, configuration_group_description, sort_order, visible) VALUES (NULL, 'Simple SEO URLs', 'Set Simple SEO URLs Options', '1', '1');
SET @configuration_group_id=last_insert_id();
UPDATE configuration_group SET sort_order = @configuration_group_id WHERE configuration_group_id = @configuration_group_id;

INSERT INTO configuration (configuration_id, configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, last_modified, date_added, use_function, set_function) VALUES
(NULL, 'File extension', 'SSU_FILE_EXTENSION', '', 'Set the file extension you want (without the dot). Recommend: leave it blank. For more info please read the docs', @configuration_group_id, 1, '2011-12-14 07:57:06', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Name delimiter', 'SSU_NAME_DELIMITER', '-', 'Set delimiter to replace all non alpha-numeric characters in product/category names', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, 'zen_cfg_select_option(array(''-'', ''.''),'),
(NULL, 'ID delimiter', 'SSU_ID_DELIMITER', '-', 'Set delimiter separate product/category names and their ids', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, 'zen_cfg_select_option(array(''-'', ''.''),'),
(NULL, 'Set max category level', 'SSU_MAX_LEVEL', '2', 'When you visit sub categories, SSU will stack the name of the sub cat and their parent cats into the link. You may want to limit the number of category names should be in a link', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Exclude list', 'SSU_EXCLUDE_LIST', 'advanced_search_result,redirect,popup_image_additional,download,wordpress', 'Set the list of pages that should be excluded from using seo style links, separated by comma with no blank space. Do not change this if you are not sure what you are doing', @configuration_group_id, 1, '2012-04-30 04:19:44', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Set Link Alias Status', 'SSU_LINK_ALIAS', 'true', 'Link alias allows you to replace any specific link by another link. After setting this to true, you can go to Admin->Extras->Simple SEO URL Manager and set link aliases', @configuration_group_id, 1, '2011-11-11 19:45:06', '2011-11-11 19:44:40', NULL, 'zen_cfg_select_option(array(''true'', ''false''),'),
(NULL, 'Set minimum word length', 'SSU_MINIMUM_WORD_LENGTH', '0', 'You can set a minimum word length here so SSU will remove any word shorter than then length from the product/category names displayed on the links. 1 or less mean no limit', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Set maximum name length', 'SSU_MAX_NAME_LENGTH', '0', 'You can set a maximum length here so SSU will trim your product/category names displayed on links to the set length. 0 or less means no limit', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Set SSU Status', 'SSU_STATUS', 'false', 'Turn SSU on or off', @configuration_group_id, 1, '2012-05-15 17:52:34', '2011-11-11 19:44:40', NULL, 'zen_cfg_select_option(array(''true'', ''false''),'),
(NULL, 'Set SSU Multi Language Status', 'SSU_MULTI_LANGUAGE_STATUS', 'false', 'Do not turn this on unless your site uses multi-languages', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, 'zen_cfg_select_option(array(''true'', ''false''),'),
(NULL, 'Set Query Key''s Exclude List', 'SSU_QUERY_EXCLUDE_LIST', 'zenid,gclid,number_of_uploads,number_of_downloads,action,sort,page,disp_order,filter_id,alpha_filter_id,currency,keyword', 'Set the query keys that you want SSU to avoid converting, separated by comma with no blank space', @configuration_group_id, 1, '2012-05-14 09:49:25', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Set Auto Alias Status', 'SSU_AUTO_ALIAS', 'true', 'Let SSU automatically remove identifiers from links, you have to have ssu alias on.', @configuration_group_id, 1, '2012-05-14 09:27:47', '2011-11-11 19:44:40', NULL, 'zen_cfg_select_option(array(''true'', ''false''),'),
(NULL, 'Set Category Separator', 'SSU_CATEGORY_SEPARATOR', '/', 'Set separator to separate category names.', @configuration_group_id, 1, '2011-11-11 19:44:40', '2011-11-11 19:44:40', NULL, NULL),
(NULL, 'Hide default language identifier', 'SSU_MULTI_LANGUAGE_DEFAULT_IDENTIFIER', 'true', 'This option is useful for sites that use multi-languages. You can tell SSU to not add language identifier into the links for the default language.', @configuration_group_id, 1, '2011-11-11 19:44:41', '2011-11-11 19:44:41', NULL, 'zen_cfg_select_option(array(''true'', ''false''),'),
(NULL, 'Cache reset time', 'SSU_CACHE_RESET_TIME', '1335788071', 'This value is updated automatically, do not edit', @configuration_group_id, 18, '2011-11-11 19:44:41', '2011-11-11 19:44:41', NULL, NULL);

INSERT IGNORE INTO admin_pages (page_key,language_key,main_page,page_params,menu_key,display_on_menu,sort_order) VALUES ('configSsu','BOX_CONFIGURATION_SSU','FILENAME_CONFIGURATION',CONCAT('gID=',@configuration_group_id),'configuration','Y',@configuration_group_id);

INSERT IGNORE INTO admin_pages (page_key, language_key, main_page, page_params, menu_key, display_on_menu, sort_order) VALUES ('extrasSsu', 'BOX_SSU', 'FILENAME_SSU', '', 'extras', 'Y', 99);


## DELETE FOR REINSTALL ##
##delete from configuration where configuration_key like "%SSU_%";
##delete from configuration_group where configuration_group_title = 'Simple SEO URLs';
##delete from admin_pages where language_key = "BOX_CONFIGURATION_SSU";

CREATE TABLE IF NOT EXISTS ssu_cache (
  id int(11) NOT NULL AUTO_INCREMENT,
  type varchar(55) DEFAULT NULL,
  referring_id int(11) NOT NULL,
  file varchar(255) DEFAULT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY type (type)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS links_aliases (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL,
  `link_alias` varchar(255) NOT NULL,
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `alias_type` varchar(100) NOT NULL DEFAULT 'none',
  `referring_id` int(10) NOT NULL DEFAULT '0',
  `permanent_link` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;